#include "system/task_sine.h"
#include "system/data_channel.h"
#include "system/float_word.h"

#include <math.h>

int task_sine_run( void * data ) {
	
	sine_config * task = ( sine_config * ) data;



	uint32_t data_channel_base = task->base.sink;

	uint32_t samples_per_periode = task->samples_per_periode;
	float phase = task->phase;
	float amplitude = task->amplitude;



	data_channel_clear( data_channel_base );
#if 0

	for (uint32_t i = 0; i < (DATA_CHANNEL_DEPTH/samples_per_periode); ++i)
	{

		for(uint32_t j = 0; j < (samples_per_periode); ++j)
		{

		float_word res;
		res.value = amplitude * sin((2.0*M_PI/samples_per_periode) * j + phase);



		data_channel_write( data_channel_base, res.word );
		}

	}
#endif
	
	for (uint32_t i = 0; i < DATA_CHANNEL_DEPTH; ++i)
	{

		float_word res;
		res.value = amplitude * sin((2.0*M_PI/samples_per_periode) * i + phase);



		data_channel_write( data_channel_base, res.word );

	}


    	return 0;
}
